;************************************************
;* Conversion routines for AVR's		*
;*						*
;* Copyright 2002-2003  Hans OPSTAELE		*
;*   based on code from Wayne Peacock		*
;*						*
;* Displays temperature in .5 C resolution	*
;* on a 1x16LCD panel and controls a plotter 	*
;************************************************
;* See Schematic for Hardware connections	*
;************************************************

; Requires the following 
.def	unit	= r22
.def	tens	= r23
.def	hund	= r24		; Used as Temp in hexasc!
.def	hex	= r25
 


;************************************************
;* Converts hex value to decimal (3 ASCII 	*
;* values) for user output (RS232, LCD etc....)	*
;*						*
;* Input:	hex				*
;* Output: 	unit				*
;*		tens				*
;*		hund				*
;************************************************        
 
hexdec: 
	ldi unit,0x30	; Units 
        ldi tens,0x30 	; Tens
        ldi hund,' '	; Hundreds

	cpi hex,0x64 	; Compare the quantity in Hex =>100(64 in Hex) 
        brsh hexdec1	; Over 100!
        
        cpi hex,0x0A 	; Compare if we have 10 inside the number 
        brsh hexdec2    ; Tens to convert
        add unit,hex	; Units only
        ret		
        
hexdec1:      	
	ldi hund,0x30	;zero         
hexdec1x:      	
	subi hex,0x64 	; Get hundreds by subtracting 100 
        inc hund    	   
        cpi hex,0x64    ; Repeat until under 100
        brsh hexdec1x 
         
        cpi hex,0x0A  	; Check if the result have some 10 inside. 
        brsh hexdec2 
               
hexdec2:     
	subi hex,0x0A 	; Get tens value by subtracting 10
        inc tens
        cpi hex,0x0A 	; Repeat until under 10
        brsh hexdec2 
        add unit,hex
        ret
