;************************************************
;* Delay routines for AVR's			*
;*						*
;* Copyright 2002-2003  Hans OPSTAELE		*
;*   based on code from Wayne Peacock		*
;*						*
;* Displays temperature in .5 C resolution	*
;* on a 1x16LCD panel and controls a plotter 	*
;************************************************
;* See Schematic for Hardware connections	*
;************************************************

;************************************************
;* Delay	(10Mhz)				*
;*						*
;* Input:	count1 (1 = appox. 100us)	*
;* Returns:	None				*
;* Requires:	count2				*
;************************************************

delay100:
	ldi	count2,249		; (1+1+2)*249 * 0.1s = 100s
	rjmp	wait_52

;************************************************
;* DelayX5us	(10Mhz)				*
;*						*
;* Input:	count1 (1 = appox. 5us)		*
;* Returns:	None				*
;* Requires:	count2				*
;************************************************
	
delayX5us:
	ldi 	count2,	13		; 
wait_52:
	nop				; (1+1+2)* 0.1 s = 0.4 s 
	dec	count2
	brne	wait_52
	dec	count1
	brne	delayX5us
	ret
